Index: WAeUP_SRP/base/WAeUPTool.py
===================================================================
--- WAeUP_SRP/base/WAeUPTool.py	(revision 3171)
+++ WAeUP_SRP/base/WAeUPTool.py	(revision 3172)
@@ -2322,151 +1861,4 @@
     ###)
 
-    def old_importData(self,filename,name,edit=False,bypass_queue_catalog=False):###(
-        """load data from CSV values"""
-        import transaction
-        import random
-
-        pm = self.portal_membership
-        member = pm.getAuthenticatedMember()
-
-        logger = logging.getLogger('WAeUPTool.importData')
-        current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
-        students_folder = self.portal_url.getPortalObject().campus.students
-        start = True
-        tr_count = 0
-        total_imported = 0
-        total_not_imported = 0
-        total = 0
-        iname = "import_%s" % name
-        if iname in ('import_application','import_course_result',):
-            commit_after = 2000
-        else:
-            commit_after = 100
-        stool = getToolByName(self, 'portal_schemas')
-        ltool = getToolByName(self, 'portal_layouts')
-        schema = stool._getOb(iname)
-        if schema is None:
-            em = 'No such schema %s' % iname
-            logger.error('No such schema %s' % iname)
-            return em
-        layout = ltool._getOb(iname)
-        if layout is None:
-            em = 'No such layout %s' % iname
-            logger.error(em)
-            return em
-        validators = {}
-        for widget in layout.keys():
-            validators[widget] = layout[widget].validate
-        mode = "create"
-        if edit:
-            if filename.endswith('_toDelete'):
-                mode = "delete"
-            else:
-                mode = "edit"
-        importer_name = "mass_%(mode)s_%(name)s" % vars()
-        importer = getattr(self, '%s' % importer_name,None)
-        if importer is None:
-            em = 'No importer function %s' % importer_name
-            logger.error(em)
-            return em
-        not_imported = []
-        imported = []
-        try:
-            items = csv.DictReader(open("%s/import/%s.csv" % (i_home,filename),"rb"))
-        except:
-            em = 'Error reading %s.csv' % filename
-            logger.error(em)
-            return em
-        for item in items:
-            #import pdb;pdb.set_trace()
-            item = dict((k.strip(),l.strip()) for (k,l) in item.items())
-            if start:
-                start = False
-                adapters = [MappingStorageAdapter(schema, item)]
-                logger.info('%s starts import from %s.csv in %s mode with schema and layout %s' % (member,filename,mode,iname))
-                attrs = csv.reader(open("%s/import/%s.csv" % (i_home,filename),"rb")).next()
-                import_keys = [k.strip() for k in attrs if not k.strip().startswith('ignore')]
-                diff2schema = set(import_keys).difference(set(schema.keys()))
-                diff2layout = set(import_keys).difference(set(layout.keys()))
-                if diff2schema:
-                    em = 'not ignorable key(s): "%s" found in heading' % ", ".join(diff2schema)
-                    return em
-                if mode == "create":
-                    required_keys = [layout.getIdUnprefixed(id)
-                                     for id,widget in layout.objectItems()
-                                     if widget.is_required]
-                    if not set(required_keys).issubset(set(import_keys)):
-                        diff2import = set(required_keys).difference(set(import_keys))
-                        em = 'required key(s): "%s" not found in heading' % ", ".join(diff2import)
-                        return em
-                s = ','.join(['"%s"' % fn for fn in import_keys])
-                open("%s/import/%s_not_imported%s.csv" % (i_home,filename,current),"a").write(s + ',"Error"'+ '\n')
-                s = '"id",' + s
-                open("%s/import/%s_imported%s.csv" % (i_home,filename,current),"a").write(s + '\n')
-                format = ','.join(['"%%(%s)s"' % fn for fn in import_keys])
-                format_error = format + ',"%(Error)s"'
-                format = '"%(id)s",'+ format
-
-            dm = DataModel(item, adapters,context=self)
-            ds = DataStructure(data=item,datamodel=dm)
-            error_string = ""
-            total += 1
-            error_count = 0
-            for k in import_keys:
-                if not validators[k](ds,mode=mode):
-                    if error_count:
-                        error_string += ' ++ '
-                    error_string += "%s: %s" % (k,
-                                                  self.translation_service(ds.getError(k),
-                                                                           ds.getErrorMapping(k)))
-                    error_count += 1
-            if not error_string:
-                temp_item = item.copy()
-                temp_item.update(dm)
-                temp_item['id'],error = importer(temp_item)
-                if error:
-                    error_string += error
-                else:
-                    item = temp_item
-            if error_string:
-                item['Error'] = error_string
-                not_imported.append(format_error % item)
-                total_not_imported += 1
-            else:
-                em = format % item
-                imported.append(em)
-                tr_count += 1
-                total_imported += 1
-                logger.info("%(total_imported)d of %(total)d imported in %(mode)s mode, %(em)s" % vars())
-
-            if total and not total % commit_after:
-                transaction.commit()
-                if len(not_imported) > 0:
-                    open("%s/import/%s_not_imported%s.csv" % (i_home,filename,current),"a").write(
-                             '\n'.join(not_imported) + '\n')
-                    not_imported = []
-                if len(imported) > 0:
-                    open("%s/import/%s_imported%s.csv" % (i_home,filename,current),"a").write(
-                             '\n'.join(imported) + '\n')
-                    imported = []
-                em = '%d transactions committed\n' % (tr_count)
-                regs = []
-                logger.info(em)
-                tr_count = 0
-                #if total > 100:
-                #    return
-        if len(imported) > 0:
-            open("%s/import/%s_imported%s.csv" % (i_home,filename,current),"a").write(
-                                                '\n'.join(imported))
-        if len(not_imported) > 0:
-            open("%s/import/%s_not_imported%s.csv" % (i_home,filename,current),"a").write(
-                                                '\n'.join(not_imported))
-        #if mode.endswith('e'):
-        #    mode = mode[:-1]
-        em = "Finished importing in %(mode)s mode from %(filename)s.csv: %(total_imported)d imported, %(total_not_imported)d not imported (of total %(total)d)" % vars()
-        logger.info(em)
-        return em
-    ###)
-
     security.declareProtected(ModifyPortalContent,"moveImagesToFS")###(
     def moveImagesToFS(self,student_id="O738726"):
Index: WAeUP_SRP/base/doc/srp_documentation.mm
===================================================================
--- WAeUP_SRP/base/doc/srp_documentation.mm	(revision 3171)
+++ WAeUP_SRP/base/doc/srp_documentation.mm	(revision 3172)
@@ -2,17 +2,4 @@
 <!-- To view this file, download free mind mapping software FreeMind from http://freemind.sourceforge.net -->
 <node CREATED="1170079518946" ID="Freemind_Link_650524897" MODIFIED="1172489583516" TEXT="WAeUP Documentation">
-<node CREATED="1172489553062" ID="Freemind_Link_1276207160" MODIFIED="1172489556316" POSITION="right" TEXT="Glossary">
-<node CREATED="1172588742298" ID="Freemind_Link_495359346" LINK="../profiles/default/schemas.xml" MODIFIED="1173007237566" TEXT="Field Names (Attributes)"/>
-<node CREATED="1172588782286" ID="Freemind_Link_1234262632" LINK="../profiles/default/types.xml" MODIFIED="1172588916308" TEXT="Types"/>
-<node CREATED="1172588791669" ID="Freemind_Link_832896495" LINK="../profiles/default/layouts.xml" MODIFIED="1173007318993" TEXT="Labels (Titles)"/>
-<node CREATED="1196238383254" ID="Freemind_Link_105251244" MODIFIED="1196238410482" TEXT="Variables Naming">
-<node CREATED="1196238414175" ID="Freemind_Link_1389091182" MODIFIED="1196238448729" TEXT="Student">
-<node CREATED="1196238450567" ID="Freemind_Link_412992846" MODIFIED="1196239946904" TEXT="students_folder : &#xa;  the folder with students "/>
-<node CREATED="1196240327175" ID="Freemind_Link_1324355897" MODIFIED="1196240334961" TEXT="student_id"/>
-<node CREATED="1196240336208" ID="Freemind_Link_392767031" MODIFIED="1196240345004" TEXT="student_obj"/>
-<node CREATED="1196239950564" ID="Freemind_Link_1283570746" MODIFIED="1196240283454" TEXT="student_record:&#xa;record from students_catalog&#xa;students_catalog.getRecordByKey(student_id)&#xa;"/>
-</node>
-</node>
-</node>
 <node CREATED="1172489529057" FOLDED="true" ID="Freemind_Link_43083883" MODIFIED="1172489545651" POSITION="right" TEXT="SRP Data Structure">
 <node CREATED="1170079621592" ID="Freemind_Link_1297017754" MODIFIED="1170079640872" TEXT="Campus">
@@ -131,5 +118,5 @@
 <node CREATED="1172156481009" ID="Freemind_Link_1817393683" LINK="waeup_student_subobject_wf.gif" MODIFIED="1172903933018" TEXT="Diagram"/>
 </node>
-<node CREATED="1170883343230" FOLDED="true" ID="Freemind_Link_998392827" MODIFIED="1172162754390" TEXT="User Interface">
+<node CREATED="1170883343230" ID="Freemind_Link_998392827" MODIFIED="1172162754390" TEXT="User Interface">
 <node CREATED="1170883352226" FOLDED="true" ID="Freemind_Link_556396570" MODIFIED="1172163796143" TEXT="Student">
 <node CREATED="1171124982312" ID="Freemind_Link_683557361" LINK="../profiles/default/layouts/student_clearance_fe.xml" MODIFIED="1172590208847" TEXT="Layout: student_clearance_fe" VSHIFT="2"/>
@@ -205,5 +192,5 @@
 </node>
 </node>
-<node CREATED="1170082200667" ID="Freemind_Link_140160478" MODIFIED="1170082364784" TEXT="Payments">
+<node CREATED="1170082200667" FOLDED="true" ID="Freemind_Link_140160478" MODIFIED="1170082364784" TEXT="Payments">
 <node CREATED="1171711430276" ID="Freemind_Link_86727434" MODIFIED="1171711435834" TEXT="Id: payments"/>
 <node CREATED="1171711367726" ID="Freemind_Link_1873791240" MODIFIED="1171711381666" TEXT="Type: PaymentsFolder"/>
@@ -330,12 +317,37 @@
 </node>
 </node>
-<node CREATED="1200500239581" ID="Freemind_Link_318351857" MODIFIED="1200500251927" POSITION="right" TEXT="Old Documentation">
-<node CREATED="1200500254038" ID="Freemind_Link_1556830810" LINK="../../WAeUP_Doc/InstructionsPart1.html" MODIFIED="1200500331010" TEXT="InstructionsPart1"/>
-<node CREATED="1200500254038" ID="Freemind_Link_1914051391" LINK="../../WAeUP_Doc/InstructionsPart2.html" MODIFIED="1200500386200" TEXT="InstructionsPart2"/>
-<node CREATED="1200500254038" ID="Freemind_Link_49864370" LINK="../../WAeUP_Doc/InstructionsPart3.html" MODIFIED="1200500412566" TEXT="InstructionsPart3"/>
-<node CREATED="1200500254038" ID="Freemind_Link_1242839170" LINK="../../WAeUP_Doc/InstructionsPart4.html" MODIFIED="1200500436427" TEXT="InstructionsPart4"/>
-<node CREATED="1200500254038" ID="Freemind_Link_629032224" LINK="../../WAeUP_Doc/InstructionsPart5.html" MODIFIED="1200500454751" TEXT="InstructionsPart5"/>
-<node CREATED="1200500254038" ID="Freemind_Link_1794158955" LINK="../../WAeUP_Doc/InstructionsPart6.html" MODIFIED="1200500470854" TEXT="InstructionsPart6"/>
-<node CREATED="1200500254038" ID="Freemind_Link_350494723" LINK="../../WAeUP_Doc/InstructionsPart7.html" MODIFIED="1200500488122" TEXT="InstructionsPart7"/>
+<node CREATED="1200500239581" FOLDED="true" ID="Freemind_Link_318351857" MODIFIED="1200500251927" POSITION="left" TEXT="Old Documentation">
+<node CREATED="1200500254038" ID="Freemind_Link_1556830810" LINK="file:///home/perry/Zope/Products/WAeUP_Doc/InstructionsPart1.html" MODIFIED="1200561147628" TEXT="Setup of an SRP instance"/>
+<node CREATED="1200500254038" ID="Freemind_Link_1914051391" LINK="../../WAeUP_Doc/InstructionsPart2.html" MODIFIED="1200502851884" TEXT="SRP Backend Usage"/>
+<node CREATED="1200500254038" ID="Freemind_Link_1794158955" LINK="../../WAeUP_Doc/InstructionsPart6.html" MODIFIED="1200503022233" TEXT="Contact forms"/>
+<node CREATED="1200500254038" ID="Freemind_Link_1242839170" LINK="../../WAeUP_Doc/InstructionsPart4.html" MODIFIED="1200502952099" TEXT="Testing Accommodation"/>
+<node CREATED="1200500254038" ID="Freemind_Link_49864370" LINK="../../WAeUP_Doc/InstructionsPart3.html" MODIFIED="1200503076521" TEXT="Testing Application"/>
+<node CREATED="1200500254038" ID="Freemind_Link_350494723" LINK="../../WAeUP_Doc/InstructionsPart7.html" MODIFIED="1200503054207" TEXT="Testing Clearance"/>
+<node CREATED="1200500254038" ID="Freemind_Link_629032224" LINK="../../WAeUP_Doc/InstructionsPart5.html" MODIFIED="1200502991059" TEXT="Testing PUME"/>
+</node>
+<node CREATED="1200931065202" ID="Freemind_Link_1866715831" MODIFIED="1200931080820" POSITION="left" TEXT="New Documentation">
+<node CREATED="1200500254038" ID="Freemind_Link_1876930383" LINK="../../WAeUP_Doc/ImportVerdicts.html" MODIFIED="1200931201900" TEXT="Import Verdicts HOWTO"/>
+<node CREATED="1200500254038" ID="Freemind_Link_1970450916" LINK="../../WAeUP_Doc/ImportNew.html" MODIFIED="1203323590449" TEXT="New Import procedure "/>
+</node>
+<node CREATED="1172489553062" FOLDED="true" ID="Freemind_Link_1276207160" MODIFIED="1172489556316" POSITION="left" TEXT="Glossary">
+<node CREATED="1172588742298" ID="Freemind_Link_495359346" LINK="../profiles/default/schemas.xml" MODIFIED="1173007237566" TEXT="Field Names (Attributes)"/>
+<node CREATED="1172588782286" ID="Freemind_Link_1234262632" LINK="../profiles/default/types.xml" MODIFIED="1172588916308" TEXT="Types"/>
+<node CREATED="1172588791669" ID="Freemind_Link_832896495" LINK="../profiles/default/layouts.xml" MODIFIED="1173007318993" TEXT="Labels (Titles)"/>
+<node CREATED="1196238383254" ID="Freemind_Link_105251244" MODIFIED="1196238410482" TEXT="Variables Naming">
+<node CREATED="1196238414175" ID="Freemind_Link_1389091182" MODIFIED="1196238448729" TEXT="Student">
+<node CREATED="1196238450567" ID="Freemind_Link_412992846" MODIFIED="1196239946904" TEXT="students_folder : &#xa;  the folder with students "/>
+<node CREATED="1196240327175" ID="Freemind_Link_1324355897" MODIFIED="1196240334961" TEXT="student_id"/>
+<node CREATED="1196240336208" ID="Freemind_Link_392767031" MODIFIED="1196240345004" TEXT="student_obj"/>
+<node CREATED="1196239950564" ID="Freemind_Link_1283570746" MODIFIED="1196240283454" TEXT="student_record:&#xa;record from students_catalog&#xa;students_catalog.getRecordByKey(student_id)&#xa;"/>
+</node>
+</node>
+</node>
+<node CREATED="1201877638475" ID="Freemind_Link_312955008" MODIFIED="1201877709483" POSITION="right" TEXT="Quantity structure">
+<node CREATED="1201877714895" ID="Freemind_Link_1862106138" MODIFIED="1201877724946" TEXT="Students">
+<node CREATED="1201877848576" ID="Freemind_Link_552788283" MODIFIED="1201877974303" TEXT="Zope Database: "/>
+<node CREATED="1201877861169" ID="Freemind_Link_759610055" MODIFIED="1201877937556" TEXT="Filesystem: Images aprox 600 kb per student"/>
+</node>
+<node CREATED="1201877727911" ID="Freemind_Link_380010877" MODIFIED="1201877735965" TEXT="Academics"/>
+<node CREATED="1201877737347" ID="Freemind_Link_764317466" MODIFIED="1201877737347" TEXT=""/>
 </node>
 </node>
Index: WAeUP_SRP/base/utils.py
===================================================================
--- WAeUP_SRP/base/utils.py	(revision 3172)
+++ WAeUP_SRP/base/utils.py	(revision 3172)
@@ -0,0 +1,29 @@
+#-*- mode: python; mode: fold -*-
+# (C) Copyright 2005 The WAeUP group  <http://www.waeup.org>
+# Author: Joachim Schmitz (js@aixtraware.de)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+# 02111-1307, USA.
+#
+# $Id$
+"""
+Standalone utils.
+"""
+import md5
+def makeDigest(item,data_keys):
+    d = {}
+    for key in data_keys:
+        d[key] = str(item.get(key,''))
+    return md5.new(str(d)).digest()
+
